//
//  DimModel.m
//  dim
//

#import "DimModel.h"

@implementation DimUser

+ (DimUser *)initWithTimUser:(TIMUserProfile *)timUserProfile {
    DimUser *dimUser = [[DimUser alloc]init];
    dimUser.identifier = timUserProfile.identifier;
    dimUser.nickName = timUserProfile.nickname;
    dimUser.faceURL = timUserProfile.faceURL;
    dimUser.selfSignature = [[NSString alloc]initWithData:timUserProfile.selfSignature  encoding:NSUTF8StringEncoding];
    dimUser.gender = timUserProfile.gender ? timUserProfile.gender : 1;
    dimUser.birthday = timUserProfile.birthday;
    dimUser.location = [[NSString alloc]initWithData:timUserProfile.location  encoding:NSUTF8StringEncoding];
    return dimUser;
}

@end

@implementation DimConversation

+ (DimConversation *)initWithTIMConversation:(TIMConversation *)timConversation {
    DimConversation *dimConversation = [[DimConversation alloc]init];
    dimConversation.identifier = timConversation.getReceiver;

    dimConversation.conversationType = timConversation.getType;
    dimConversation.unReadNum = timConversation.getUnReadMessageNum;
    TIMMessage *lastMsg = timConversation.getLastMsg;
    TIMElem *msg = [lastMsg getElem:0];
    dimConversation.message = msg;
    
    NSTimeZone *zone = [NSTimeZone systemTimeZone];
    NSInteger interval = [zone secondsFromGMTForDate:lastMsg.timestamp];
    dimConversation.sendTime = interval;
    
    
    return dimConversation;
}
@end

@implementation DimMessage

+ (DimMessage *)initWithTIMMessage:(TIMMessage *)timMessage {
    DimMessage *dimMessage = [[DimMessage alloc]init];
    dimMessage.identifier = timMessage.sender;
    dimMessage.conversationType = timMessage.getConversation.getType;
    dimMessage.message = [timMessage getElem:0];
    dimMessage.isRead = timMessage.isReaded;
    dimMessage.isSelf = timMessage.isSelf;
    NSTimeZone *zone = [NSTimeZone systemTimeZone];
    NSInteger interval = [zone secondsFromGMTForDate:timMessage.timestamp];
    dimMessage.sendTime = interval;
    return dimMessage;
}
@end
